	include	"FLIB.H"
	include	"GRAPHLIB.H"
	include	"HEXLIB.H"
	include	"TIOS.H"
	xdef	_main
	xdef	_comment

;-------------------------------------------------------------
;			TEXT TESTER V1.0
; Programme fait par VIVES Fabien.
; Email : vives@univ-aix.fr
; Lire LISEZMOI.TXT pour plus d'infos
;-------------------------------------------------------------
; Program made with Fargo Program Editor v2.0
; Benoit SCHERRER - p.c.scherrer@wanadoo.fr
;-------------------------------------------------------------
;************************** MACRO ****************************

WriteStr MACRO				; Syntaxe : x/y/Couleur/Chaine
	move.w \3,-(a7)			;on met la couleur dans la pile.
	pea \4(pc)			;on met le chaine a afficher dans la pile.
	move.w \2,-(a7)			;on met la coordonnee y dans la pile.	
	move.w \1,-(a7)			;on met la coordonnee x dans la pile.
	jsr tios::DrawStrXY		;on va chercher la routine dans la librairie TIOS
	lea 10(a7),a7			;on reinitialise la pile de 10 = 2+4+2+2
	ENDM

;***************** Start of FARGO II Program ******************

_main:
	movem.l d0-d2/a0-a1,-(a7)	;on sauve les registres que l'on va modifier plutard.
	move.w #0,cmptr			;on initialise un compteur.
	jsr flib::clr_scr		;on efface l'ecran.
	move.w #0,-(a7)			;on mets la Fonte 0 dans la pile.( petite fonte ).
	jsr tios::FontSetSys		;on appelle la routine dans la libraire TIOS.
	lea 2(a7),a7			;on reinitialise la pile de 2.
	WriteStr #0,#0,#1,intro		;on affiche la phrase intro.
	lea phrase(pc),a1		;A1 pointe sur la var " phrase ".
	clr.l (a1)			;on efface le longmot ou pointe A1.
	add.w #4,a1			;on ajoute 4 bytes a A1.
	clr.l (a1)			;on efface le longmot ou pointe A1.Maintenant on est sur
					;que la variable " phrase " est totalement nettoyee.

	sub.w #4,a1			;A1 pointe a nouveau la ou est la var " phrase ".
	move.w #2,-(a7)			;on met la Fonte 2 dans la pile.
	jsr tios::FontSetSys
	lea 2(a7),a7			;on reinitialise la pile de 2.

;MAINTENANT ON VA AFFICHER AU FUR ET A MESURE LES LETTRES TAPEES PENDANT LA
;SAISIE DU MOT, ET ON VA LES SAUVER DANS LA VARIABLE " PHRASE ".

saisie:
	jsr flib::idle_loop		;cette routine attend qu'une touche soit pressee.
					;la valeur ASCII de la touche est mise dans D0

	cmp.w #13,d0			;est-ce que c'est ENTER ?
	beq finsaisie			;si oui aller a " finsaisie ".
	cmp.w #257,d0			;c'est BACKSPACE ?
	beq backspce			;si oui aller a " backspce".
	add.w #1,cmptr			;on incremente le compteur de 1. Ce compteur est pour
					;limiter le nombre de lettres du mot a 8.
	cmp.w #9,cmptr
	beq retour			;si le compteur est a 9. on va sur " retour ".

	move.b d0,(a1)+			;on place la lettre la ou pointe A1. C-a-d dans la 
					;variable " phrase " et on incremente A1 de 1 Byte.
	WriteStr #10,#10,#1,phrase	;on affiche la variable " phrase ". Je ne prends pas la 
					;peine d'effacer. Je reecris par dessus. Si j'avais deja
					;tape "ess", et que je tape ensuite " a ". On affiche
					;" essa " par dessus " ess ".
	bra saisie			;on retourne a " saisie " pour continuer la saisie.

retour:
	sub.w #1,cmptr			;on enleve 1 car juste avant on a rajoute 1. On est dans 
					;retour car on a atteint la limite des 8 lettres. Tant que 
					;l'utilisateur ne tape pas ENTER pour finir, ou Backspace
					;pour effacer une lettre, on vient ici.
	bra saisie			;on retourne a saisie.

backspce:
	cmp.w #0,cmptr			;on verifie si il y a au moins 1 lettre a effacer. Si il n'y
					;en a pas, cmptr est a 0.
	beq saisie			; cmptr=0 ? alors retour a " saisie ".
	sub.w #1,cmptr			;comme on efface une lettre, on decremente aussi le
					;compteur.
	WriteStr #10,#10,#2,phrase   	;La, pour ne pas effacer TOUT l'ecran, on efface juste
					;la phrase. Pour cela on reecrit la variable  " phrase "
					;avec la couleur 2.
	move.b #0,-(a1)			;on enleve 1 Byte a A1, et on met #0 la ou pointe A1.
	WriteStr #10,#10,#1,phrase  	;on affiche la var " phrase ".
	bra saisie

finsaisie:
	move.w #0,ancfont	;on initialise la var " ancfont ".
	move.w #50,Posx		;----------------------------- " Posx ".
	move.w #50,Posy		;----------------------------- " Posy ".
	move.w #1,color		;----------------------------- " color ".

boucle1:
	jsr flib::clr_scr				;on efface l'ecran.
	WriteStr Posx,Posy,color,phrase			;on affiche la var " phrase ".

boucle2:
	jsr flib::idle_loop	;on attend qu'une touche soit pressee.
	cmp.w #264,d0		; ESC ?
	beq fini
	cmp.w #268,d0		; F1 ?
	beq Fct1
	cmp.w #269,d0		; F2 ?
	beq Fct2
	cmp.w #270,d0		; F3 ?
	beq Fct3
	cmp.w #271,d0		; F4 ?
	beq Fct4
	cmp.w #272,d0		; F5 ?
	beq Fct5
	cmp.w #337,d0		; CURSEUR GAUCHE ?
	beq gauche
	cmp.w #338,d0		; CURSEUR HAUT ?
	beq haut
	cmp.w #340,d0		; CURSEUR DROITE ?
	beq droite
	cmp.w #344,d0		; CURSEUR BAS ?
	beq bas
	cmp.w #273,d0		; F6 ?
	beq Fct6
	cmp.w #13,d0			; ENTER ?
	beq Enter
	bra boucle2

haut:
	cmp.w #0,Posy		;on regarde si on est au bord superieur de l'ecran.
	beq boucle2		;si oui on ne change rien et on repart sur " boucle2 ".
	sub.w #1,Posy	
	bra boucle1
bas:
	cmp.w #127,Posy		;on regarde si on est au bord inferieur de l'ecran.
	beq boucle2
	add.w #1,Posy
	bra boucle1
gauche:
	cmp.w #0,Posx		;on regarde si on est au bord gauche de l'ecran.
	beq boucle2
	sub.w #1,Posx
	bra boucle1
droite:
	cmp.w #239,Posx		;on regrade si on est au bord droit de l'ecran.
	beq boucle2
	add.w #1,Posx
	bra boucle1
Enter:
	clr.l d0
	move.w #2,-(a7)			;on met la Fonte 2 dans la pile.
	jsr tios::FontSetSys		;On fixe la Fonte du systeme. Cette routine retourne
					;dans D0 la valeur de la fonte avant le changement.
	lea 2(a7),a7			;on reinitialise la pile de 2.
	move.w d0,ancfont		;on sauvegarde l'ancienne Fonte dans " ancfont ".
	jsr flib::clr_scr		
	WriteStr #40,#50,#1,infos	;on affiche le texte " infos ".
	move.w Posx,d0			;on met dans D0 le chiffre que l'on veut convertir en
					;chaine decimale.
	moveq #3,d1			;on met dans D1 la taille qu'aura notre chiffre. Il fera ici
					;3 nombres.
	lea strbuf(pc),a0		;on charge dans A0 l'endroit ou se trouve la var " strbuf ".
	bsr ConvStr			;on rejoint la routine qui convertit.
	WriteStr #60,#60,#1,strbuf	;on affiche le resultat.
	move.w Posy,d0			;idem qu'au dessus pour Posy
	moveq #3,d1
	lea strbuf(pc),a0
	bsr ConvStr
	WriteStr #90,#60,#1,strbuf
	jsr flib::idle_loop		;on attend qu'une touche soit pressee.
	move.w ancfont,-(a7)		;on recharge la Fonte qu'on avait avant pour notre mot.
	jsr tios::FontSetSys
	lea 2(a7),a7
	bra boucle1

Fct1:
	move.w #0,-(a7)		;on charge la Fonte 0 dans la pile.
	bra suite
Fct2:
	move.w #1,-(a7)		;on charge la Fonte 1 dans la pile.
	bra suite
Fct3:
	move.w #2,-(a7)		;on charge la Fonte 2 dans la pile.
	bra suite
Fct4:
	move.w #0,color		;on charge la couleur 0 dans la var " color ".
	bra boucle1
Fct5:
	move.w #1,color		;on charge la couleur 1 dans la var " color ".
	bra boucle1
Fct6:
	move.w #2,color		;on charge la couleur 2 dans la var " color ".
	bra boucle1
	
suite:
	jsr tios::FontSetSys		;on va chercher la routine qui change la Fonte.
	lea 2(a7),a7			;on reinitialise la pile de 2.
	bra boucle1
fini:
	movem.l (a7)+,d0-d2/a0-a1	;on restaure les registres qu'on a modifies.
	rts
;******************************************* ROUTINE *********************************************


;J'ai recupere cette routine dans le prog DUMBADV.
;Cette routine convertit un chiffre en chaine decimale dans le but de l'afficher.
;a0 pointe sur strbuf.
;d1 contient le nombre de bytes que va faire notre nombre. ici on aura un chiffre a 3 nombres.
;d0 contient le chiffre que l'on doit convertir.

ConvStr:
 	adda.l  d1,a0		;a0 pointe maintenant a "adresse de strbuff " + 3 bytes.
 	clr.b   (a0)
 	subq.b  #1,d1		;d1 nous sert de compteur.
RepConv:
 	divu	 #10,d0		;on divise par dix.  Car on veut notre chiffre en base dix.

 	move.l  d0,d2		;dans D0 : le mot de poids fort on a le reste
				;dans le mot de poids faible le quotient.
 	lsr.l	 #8,d2
 	lsr.l	 #8,d2		;on decale deux fois vers la droite pour avoir le mot de poids
				;fort a la place du mot de poids faible.( le mot de poids faible
				;est detruit ).

 	add.b	 #48,d2		;on ajoute 48 au reste de la division car le code ASCII de la 
				;touche " 1 " par exemple est : 49. Pour " 2 " c'est 50.

 	move.b  d2,-(a0)	;On revient d'un byte en arriere, et on place le contenu de d2.

 	and.l	 #$FFFF,d0	;sincerement je ne vois pas l'utilite de cette ligne.
				;a priori ca ne change rien au contenu de d0.

 	dbra	 d1,RepConv	;on decremente d1 de 1. Si d1 vaut " -1 ", on quitte.
 	rts			;on retourne a notre prog.

;******************** Program Variables ***********************
Posx dc.l 0		;Coordonnee x de notre mot.
Posy dc.l 0		;Coordonnee y de notre mot.
strbuf dc.l 0,0		;cette var contiendra pendant notre prog la chaine Posx ou Posy
			;quand on veut l'afficher.
phrase dc.l 0,0		;idem que precedement sauf qu'elle contiendra notre mot.
cmptr dc.w 0		;un compteur.
color dc.w 0		;la couleur de notre mot.
ancfont dc.w 0		;cette var sert a garder en memoire une Fonte.
intro dc.b "Type text to Display. ENTER to end. ( 8 letters max ).",0
infos dc.b "Position X / Y :",0
_comment	dc.b	"Text Tester v1.0",0
;********************** End of Program ************************
	end
